#include "nautilus-adamext.h"

#include <libnautilus-extension/nautilus-menu-provider.h>

#include <stdlib.h>
#include <gtk/gtk.h>

static GType adamext_type = 0;
static GType type_list[1];

static GList *
nautilus_adamext_get_background_items (NautilusMenuProvider *provider,
					     GtkWidget		  *window,
					     NautilusFileInfo	  *file_info)
{
	GList *items = NULL;
	return items;
}


GList *
nautilus_adamext_get_file_items (NautilusMenuProvider *provider,
				       GtkWidget            *window,
				       GList                *files)
{
	GList *items = NULL;
	int i;
    NautilusMenuItem *item;
    gchar label[8];
    float rnum;
    
	for(i=0; i<5; i++){
        sprintf(label, "Item::%d", i);
        
        rnum = (RAND_MAX/rand());
        if(rnum > 2){
	        item = nautilus_menu_item_new(label, label, "Tooltip1", NULL);
        	items = g_list_append(items, item);
        }
    }
	return items;
}

static void
nautilus_adamext_menu_provider_iface_init (NautilusMenuProviderIface *iface)
{
	iface->get_background_items = nautilus_adamext_get_background_items;
	iface->get_file_items = nautilus_adamext_get_file_items;
}

GType
nautilus_adamext_get_type (void) 
{
	return adamext_type;
}


void
nautilus_adamext_register_type (GTypeModule *module)
{
	static const GTypeInfo info = {
		sizeof (NautilusAdamExtClass),
		(GBaseInitFunc) NULL,
		(GBaseFinalizeFunc) NULL,
		(GClassInitFunc) NULL,
		(GClassFinalizeFunc) NULL,
		NULL,
		sizeof (NautilusAdamExt),
		0,
		(GInstanceInitFunc) NULL,
	};

	static const GInterfaceInfo menu_provider_iface_info = {
		(GInterfaceInitFunc) nautilus_adamext_menu_provider_iface_init,
		NULL,
		NULL
	};

	adamext_type = g_type_module_register_type (module,
						     G_TYPE_OBJECT,
						     "NautilusAdamExt",
						     &info, 0);

	g_type_module_add_interface (module,
				     adamext_type,
				     NAUTILUS_TYPE_MENU_PROVIDER,
				     &menu_provider_iface_info);
}

void
nautilus_module_initialize (GTypeModule *module)
{
	g_print ("Initializing Adam's test extension\n");

	nautilus_adamext_register_type (module);
	type_list[0] = NAUTILUS_TYPE_ADAMEXT;
}

void
nautilus_module_shutdown (void)
{
	g_print ("Shutting down Adam's extension\n");
}

void 
nautilus_module_list_types (const GType **types,
			    int          *num_types)
{
	*types = type_list;
	*num_types = G_N_ELEMENTS (type_list);
}
